diff -urNp linux-2.6.32.24/arch/x86/vdso/vdso32-setup.c linux-2.6.32.24/arch/x86/vdso/vdso32-setup.c
--- linux-2.6.32.24/arch/x86/vdso/vdso32-setup.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/vdso/vdso32-setup.c	2010-09-04 15:54:51.000000000 -0400
@@ -25,6 +25,7 @@
 #include <asm/tlbflush.h>
 #include <asm/vdso.h>
 #include <asm/proto.h>
+#include <asm/mman.h>
 
 enum {
 	VDSO_DISABLED = 0,
@@ -226,7 +227,7 @@ static inline void map_compat_vdso(int m
 void enable_sep_cpu(void)
 {
 	int cpu = get_cpu();
-	struct tss_struct *tss = &per_cpu(init_tss, cpu);
+	struct tss_struct *tss = init_tss + cpu;
 
 	if (!boot_cpu_has(X86_FEATURE_SEP)) {
 		put_cpu();
@@ -249,7 +250,7 @@ static int __init gate_vma_init(void)
 	gate_vma.vm_start = FIXADDR_USER_START;
 	gate_vma.vm_end = FIXADDR_USER_END;
 	gate_vma.vm_flags = VM_READ | VM_MAYREAD | VM_EXEC | VM_MAYEXEC;
-	gate_vma.vm_page_prot = __P101;
+	gate_vma.vm_page_prot = vm_get_page_prot(gate_vma.vm_flags);
 	/*
 	 * Make sure the vDSO gets into every core dump.
 	 * Dumping its contents makes post-mortem fully interpretable later
@@ -331,14 +332,14 @@ int arch_setup_additional_pages(struct l
 	if (compat)
 		addr = VDSO_HIGH_BASE;
 	else {
-		addr = get_unmapped_area(NULL, 0, PAGE_SIZE, 0, 0);
+		addr = get_unmapped_area(NULL, 0, PAGE_SIZE, 0, MAP_EXECUTABLE);
 		if (IS_ERR_VALUE(addr)) {
 			ret = addr;
 			goto up_fail;
 		}
 	}
 
-	current->mm->context.vdso = (void *)addr;
+	current->mm->context.vdso = addr;
 
 	if (compat_uses_vma || !compat) {
 		/*
@@ -361,11 +362,11 @@ int arch_setup_additional_pages(struct l
 	}
 
 	current_thread_info()->sysenter_return =
-		VDSO32_SYMBOL(addr, SYSENTER_RETURN);
+		(__force void __user *)VDSO32_SYMBOL(addr, SYSENTER_RETURN);
 
   up_fail:
 	if (ret)
-		current->mm->context.vdso = NULL;
+		current->mm->context.vdso = 0;
 
 	up_write(&mm->mmap_sem);
 
@@ -388,7 +389,7 @@ static ctl_table abi_table2[] = {
 		.mode		= 0644,
 		.proc_handler	= proc_dointvec
 	},
-	{}
+	{ 0, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL }
 };
 
 static ctl_table abi_root_table2[] = {
@@ -398,7 +399,7 @@ static ctl_table abi_root_table2[] = {
 		.mode = 0555,
 		.child = abi_table2
 	},
-	{}
+	{ 0, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL }
 };
 
 static __init int ia32_binfmt_init(void)
@@ -413,8 +414,14 @@ __initcall(ia32_binfmt_init);
 
 const char *arch_vma_name(struct vm_area_struct *vma)
 {
-	if (vma->vm_mm && vma->vm_start == (long)vma->vm_mm->context.vdso)
+	if (vma->vm_mm && vma->vm_start == vma->vm_mm->context.vdso)
 		return "[vdso]";
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (vma->vm_mm && vma->vm_mirror && vma->vm_mirror->vm_start == vma->vm_mm->context.vdso)
+		return "[vdso]";
+#endif
+
 	return NULL;
 }
 
@@ -423,7 +430,7 @@ struct vm_area_struct *get_gate_vma(stru
 	struct mm_struct *mm = tsk->mm;
 
 	/* Check to see if this task was created in compat vdso mode */
-	if (mm && mm->context.vdso == (void *)VDSO_HIGH_BASE)
+	if (mm && mm->context.vdso == VDSO_HIGH_BASE)
 		return &gate_vma;
 	return NULL;
 }
diff -urNp linux-2.6.32.24/arch/x86/vdso/vdso.lds.S linux-2.6.32.24/arch/x86/vdso/vdso.lds.S
--- linux-2.6.32.24/arch/x86/vdso/vdso.lds.S	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/vdso/vdso.lds.S	2010-09-04 15:54:51.000000000 -0400
@@ -35,3 +35,9 @@ VDSO64_PRELINK = VDSO_PRELINK;
 #define VEXTERN(x)	VDSO64_ ## x = vdso_ ## x;
 #include "vextern.h"
 #undef	VEXTERN
+
+#define VEXTERN(x)	VDSO64_ ## x = __vdso_ ## x;
+VEXTERN(fallback_gettimeofday)
+VEXTERN(fallback_time)
+VEXTERN(getcpu)
+#undef	VEXTERN
diff -urNp linux-2.6.32.24/arch/x86/vdso/vextern.h linux-2.6.32.24/arch/x86/vdso/vextern.h
--- linux-2.6.32.24/arch/x86/vdso/vextern.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/vdso/vextern.h	2010-09-04 15:54:51.000000000 -0400
@@ -11,6 +11,5 @@
    put into vextern.h and be referenced as a pointer with vdso prefix.
    The main kernel later fills in the values.   */
 
-VEXTERN(jiffies)
 VEXTERN(vgetcpu_mode)
 VEXTERN(vsyscall_gtod_data)
diff -urNp linux-2.6.32.24/arch/x86/vdso/vma.c linux-2.6.32.24/arch/x86/vdso/vma.c
--- linux-2.6.32.24/arch/x86/vdso/vma.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/vdso/vma.c	2010-09-04 15:54:51.000000000 -0400
@@ -57,7 +57,7 @@ static int __init init_vdso_vars(void)
 	if (!vbase)
 		goto oom;
 
-	if (memcmp(vbase, "\177ELF", 4)) {
+	if (memcmp(vbase, ELFMAG, SELFMAG)) {
 		printk("VDSO: I'm broken; not ELF\n");
 		vdso_enabled = 0;
 	}
@@ -66,6 +66,7 @@ static int __init init_vdso_vars(void)
 	*(typeof(__ ## x) **) var_ref(VDSO64_SYMBOL(vbase, x), #x) = &__ ## x;
 #include "vextern.h"
 #undef VEXTERN
+	vunmap(vbase);
 	return 0;
 
  oom:
@@ -116,7 +117,7 @@ int arch_setup_additional_pages(struct l
 		goto up_fail;
 	}
 
-	current->mm->context.vdso = (void *)addr;
+	current->mm->context.vdso = addr;
 
 	ret = install_special_mapping(mm, addr, vdso_size,
 				      VM_READ|VM_EXEC|
@@ -124,7 +125,7 @@ int arch_setup_additional_pages(struct l
 				      VM_ALWAYSDUMP,
 				      vdso_pages);
 	if (ret) {
-		current->mm->context.vdso = NULL;
+		current->mm->context.vdso = 0;
 		goto up_fail;
 	}
 
@@ -132,10 +133,3 @@ up_fail:
 	up_write(&mm->mmap_sem);
 	return ret;
 }
-
-static __init int vdso_setup(char *s)
-{
-	vdso_enabled = simple_strtoul(s, NULL, 0);
-	return 0;
-}
-__setup("vdso=", vdso_setup);
diff -urNp linux-2.6.32.24/arch/x86/xen/enlighten.c linux-2.6.32.24/arch/x86/xen/enlighten.c
--- linux-2.6.32.24/arch/x86/xen/enlighten.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/xen/enlighten.c	2010-09-17 17:30:16.000000000 -0400
@@ -71,8 +71,6 @@ EXPORT_SYMBOL_GPL(xen_start_info);
 
 struct shared_info xen_dummy_shared_info;
 
-void *xen_initial_gdt;
-
 /*
  * Point at some empty memory to start with. We map the real shared_info
  * page as soon as fixmap is up and running.
@@ -548,7 +546,7 @@ static void xen_write_idt_entry(gate_des
 
 	preempt_disable();
 
-	start = __get_cpu_var(idt_desc).address;
+	start = (unsigned long)__get_cpu_var(idt_desc).address;
 	end = start + __get_cpu_var(idt_desc).size + 1;
 
 	xen_mc_flush();
@@ -1099,9 +1097,20 @@ asmlinkage void __init xen_start_kernel(
 	 */
 	__userpte_alloc_gfp &= ~__GFP_HIGHMEM;
 
-#ifdef CONFIG_X86_64
 	/* Work out if we support NX */
-	check_efer();
+#if defined(CONFIG_X86_64) || defined(CONFIG_X86_PAE)
+	if ((cpuid_eax(0x80000000) & 0xffff0000) == 0x80000000 &&
+	    (cpuid_edx(0x80000001) & (1U << (X86_FEATURE_NX & 31)))) {
+		unsigned l, h;
+
+#ifdef CONFIG_X86_PAE
+		nx_enabled = 1;
+#endif
+		__supported_pte_mask |= _PAGE_NX;
+		rdmsr(MSR_EFER, l, h);
+		l |= EFER_NX;
+		wrmsr(MSR_EFER, l, h);
+	}
 #endif
 
 	xen_setup_features();
@@ -1133,13 +1142,6 @@ asmlinkage void __init xen_start_kernel(
 
 	machine_ops = xen_machine_ops;
 
-	/*
-	 * The only reliable way to retain the initial address of the
-	 * percpu gdt_page is to remember it here, so we can go and
-	 * mark it RW later, when the initial percpu area is freed.
-	 */
-	xen_initial_gdt = &per_cpu(gdt_page, 0);
-
 	xen_smp_init();
 
 	pgd = (pgd_t *)xen_start_info->pt_base;
diff -urNp linux-2.6.32.24/arch/x86/xen/mmu.c linux-2.6.32.24/arch/x86/xen/mmu.c
--- linux-2.6.32.24/arch/x86/xen/mmu.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/xen/mmu.c	2010-09-04 15:54:51.000000000 -0400
@@ -1711,6 +1711,8 @@ __init pgd_t *xen_setup_kernel_pagetable
 	convert_pfn_mfn(init_level4_pgt);
 	convert_pfn_mfn(level3_ident_pgt);
 	convert_pfn_mfn(level3_kernel_pgt);
+	convert_pfn_mfn(level3_vmalloc_pgt);
+	convert_pfn_mfn(level3_vmemmap_pgt);
 
 	l3 = m2v(pgd[pgd_index(__START_KERNEL_map)].pgd);
 	l2 = m2v(l3[pud_index(__START_KERNEL_map)].pud);
@@ -1729,7 +1731,10 @@ __init pgd_t *xen_setup_kernel_pagetable
 	set_page_prot(init_level4_pgt, PAGE_KERNEL_RO);
 	set_page_prot(level3_ident_pgt, PAGE_KERNEL_RO);
 	set_page_prot(level3_kernel_pgt, PAGE_KERNEL_RO);
+	set_page_prot(level3_vmalloc_pgt, PAGE_KERNEL_RO);
+	set_page_prot(level3_vmemmap_pgt, PAGE_KERNEL_RO);
 	set_page_prot(level3_user_vsyscall, PAGE_KERNEL_RO);
+	set_page_prot(level2_vmemmap_pgt, PAGE_KERNEL_RO);
 	set_page_prot(level2_kernel_pgt, PAGE_KERNEL_RO);
 	set_page_prot(level2_fixmap_pgt, PAGE_KERNEL_RO);
 
diff -urNp linux-2.6.32.24/arch/x86/xen/smp.c linux-2.6.32.24/arch/x86/xen/smp.c
--- linux-2.6.32.24/arch/x86/xen/smp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/xen/smp.c	2010-09-04 15:54:51.000000000 -0400
@@ -167,11 +167,6 @@ static void __init xen_smp_prepare_boot_
 {
 	BUG_ON(smp_processor_id() != 0);
 	native_smp_prepare_boot_cpu();
-
-	/* We've switched to the "real" per-cpu gdt, so make sure the
-	   old memory can be recycled */
-	make_lowmem_page_readwrite(xen_initial_gdt);
-
 	xen_setup_vcpu_info_placement();
 }
 
@@ -231,8 +226,8 @@ cpu_initialize_context(unsigned int cpu,
 	gdt = get_cpu_gdt_table(cpu);
 
 	ctxt->flags = VGCF_IN_KERNEL;
-	ctxt->user_regs.ds = __USER_DS;
-	ctxt->user_regs.es = __USER_DS;
+	ctxt->user_regs.ds = __KERNEL_DS;
+	ctxt->user_regs.es = __KERNEL_DS;
 	ctxt->user_regs.ss = __KERNEL_DS;
 #ifdef CONFIG_X86_32
 	ctxt->user_regs.fs = __KERNEL_PERCPU;
diff -urNp linux-2.6.32.24/arch/x86/xen/xen-head.S linux-2.6.32.24/arch/x86/xen/xen-head.S
--- linux-2.6.32.24/arch/x86/xen/xen-head.S	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/xen/xen-head.S	2010-09-04 15:54:51.000000000 -0400
@@ -19,6 +19,17 @@ ENTRY(startup_xen)
 #ifdef CONFIG_X86_32
 	mov %esi,xen_start_info
 	mov $init_thread_union+THREAD_SIZE,%esp
+#ifdef CONFIG_SMP
+	movl $cpu_gdt_table,%edi
+	movl $__per_cpu_load,%eax
+	movw %ax,__KERNEL_PERCPU + 2(%edi)
+	rorl $16,%eax
+	movb %al,__KERNEL_PERCPU + 4(%edi)
+	movb %ah,__KERNEL_PERCPU + 7(%edi)
+	movl $__per_cpu_end - 1,%eax
+	subl $__per_cpu_start,%eax
+	movw %ax,__KERNEL_PERCPU + 0(%edi)
+#endif
 #else
 	mov %rsi,xen_start_info
 	mov $init_thread_union+THREAD_SIZE,%rsp
diff -urNp linux-2.6.32.24/arch/x86/xen/xen-ops.h linux-2.6.32.24/arch/x86/xen/xen-ops.h
--- linux-2.6.32.24/arch/x86/xen/xen-ops.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/arch/x86/xen/xen-ops.h	2010-09-04 15:54:51.000000000 -0400
@@ -10,8 +10,6 @@
 extern const char xen_hypervisor_callback[];
 extern const char xen_failsafe_callback[];
 
-extern void *xen_initial_gdt;
-
 struct trap_info;
 void xen_copy_trap_info(struct trap_info *traps);
 
diff -urNp linux-2.6.32.24/block/blk-integrity.c linux-2.6.32.24/block/blk-integrity.c
--- linux-2.6.32.24/block/blk-integrity.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/block/blk-integrity.c	2010-09-04 15:54:51.000000000 -0400
@@ -278,7 +278,7 @@ static struct attribute *integrity_attrs
 	NULL,
 };
 
-static struct sysfs_ops integrity_ops = {
+static const struct sysfs_ops integrity_ops = {
 	.show	= &integrity_attr_show,
 	.store	= &integrity_attr_store,
 };
diff -urNp linux-2.6.32.24/block/blk-iopoll.c linux-2.6.32.24/block/blk-iopoll.c
--- linux-2.6.32.24/block/blk-iopoll.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/block/blk-iopoll.c	2010-09-04 15:54:51.000000000 -0400
@@ -77,7 +77,7 @@ void blk_iopoll_complete(struct blk_iopo
 }
 EXPORT_SYMBOL(blk_iopoll_complete);
 
-static void blk_iopoll_softirq(struct softirq_action *h)
+static void blk_iopoll_softirq(void)
 {
 	struct list_head *list = &__get_cpu_var(blk_cpu_iopoll);
 	int rearm = 0, budget = blk_iopoll_budget;
diff -urNp linux-2.6.32.24/block/blk-map.c linux-2.6.32.24/block/blk-map.c
--- linux-2.6.32.24/block/blk-map.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/block/blk-map.c	2010-09-04 15:54:51.000000000 -0400
@@ -54,7 +54,7 @@ static int __blk_rq_map_user(struct requ
 	 * direct dma. else, set up kernel bounce buffers
 	 */
 	uaddr = (unsigned long) ubuf;
-	if (blk_rq_aligned(q, ubuf, len) && !map_data)
+	if (blk_rq_aligned(q, (__force void *)ubuf, len) && !map_data)
 		bio = bio_map_user(q, NULL, uaddr, len, reading, gfp_mask);
 	else
 		bio = bio_copy_user(q, map_data, uaddr, len, reading, gfp_mask);
@@ -297,7 +297,7 @@ int blk_rq_map_kern(struct request_queue
 	if (!len || !kbuf)
 		return -EINVAL;
 
-	do_copy = !blk_rq_aligned(q, kbuf, len) || object_is_on_stack(kbuf);
+	do_copy = !blk_rq_aligned(q, kbuf, len) || object_starts_on_stack(kbuf);
 	if (do_copy)
 		bio = bio_copy_kern(q, kbuf, len, gfp_mask, reading);
 	else
diff -urNp linux-2.6.32.24/block/blk-softirq.c linux-2.6.32.24/block/blk-softirq.c
--- linux-2.6.32.24/block/blk-softirq.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/block/blk-softirq.c	2010-09-04 15:54:51.000000000 -0400
@@ -17,7 +17,7 @@ static DEFINE_PER_CPU(struct list_head, 
  * Softirq action handler - move entries to local list and loop over them
  * while passing them to the queue registered handler.
  */
-static void blk_done_softirq(struct softirq_action *h)
+static void blk_done_softirq(void)
 {
 	struct list_head *cpu_list, local_list;
 
diff -urNp linux-2.6.32.24/block/blk-sysfs.c linux-2.6.32.24/block/blk-sysfs.c
--- linux-2.6.32.24/block/blk-sysfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/block/blk-sysfs.c	2010-09-04 15:54:51.000000000 -0400
@@ -414,7 +414,7 @@ static void blk_release_queue(struct kob
 	kmem_cache_free(blk_requestq_cachep, q);
 }
 
-static struct sysfs_ops queue_sysfs_ops = {
+static const struct sysfs_ops queue_sysfs_ops = {
 	.show	= queue_attr_show,
 	.store	= queue_attr_store,
 };
diff -urNp linux-2.6.32.24/block/elevator.c linux-2.6.32.24/block/elevator.c
--- linux-2.6.32.24/block/elevator.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/block/elevator.c	2010-09-04 15:54:51.000000000 -0400
@@ -889,7 +889,7 @@ elv_attr_store(struct kobject *kobj, str
 	return error;
 }
 
-static struct sysfs_ops elv_sysfs_ops = {
+static const struct sysfs_ops elv_sysfs_ops = {
 	.show	= elv_attr_show,
 	.store	= elv_attr_store,
 };
diff -urNp linux-2.6.32.24/crypto/lrw.c linux-2.6.32.24/crypto/lrw.c
--- linux-2.6.32.24/crypto/lrw.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/crypto/lrw.c	2010-09-04 15:54:51.000000000 -0400
@@ -60,7 +60,7 @@ static int setkey(struct crypto_tfm *par
 	struct priv *ctx = crypto_tfm_ctx(parent);
 	struct crypto_cipher *child = ctx->child;
 	int err, i;
-	be128 tmp = { 0 };
+	be128 tmp = { 0, 0 };
 	int bsize = crypto_cipher_blocksize(child);
 
 	crypto_cipher_clear_flags(child, CRYPTO_TFM_REQ_MASK);
diff -urNp linux-2.6.32.24/Documentation/dontdiff linux-2.6.32.24/Documentation/dontdiff
--- linux-2.6.32.24/Documentation/dontdiff	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/Documentation/dontdiff	2010-09-04 15:54:51.000000000 -0400
@@ -3,6 +3,7 @@
 *.bin
 *.cpio
 *.csp
+*.dbg
 *.dsp
 *.dvi
 *.elf
@@ -38,8 +39,10 @@
 *.tab.h
 *.tex
 *.ver
+*.vim
 *.xml
 *_MODULES
+*_reg_safe.h
 *_vga16.c
 *~
 *.9
@@ -49,11 +52,16 @@
 53c700_d.h
 CVS
 ChangeSet
+GPATH
+GRTAGS
+GSYMS
+GTAGS
 Image
 Kerntypes
 Module.markers
 Module.symvers
 PENDING
+PERF*
 SCCS
 System.map*
 TAGS
@@ -76,7 +84,10 @@ btfixupprep
 build
 bvmlinux
 bzImage*
+capflags.c
 classlist.h*
+clut_vga16.c
+common-cmds.h
 comp*.log
 compile.h*
 conf
@@ -103,13 +114,14 @@ gen_crc32table
 gen_init_cpio
 genksyms
 *_gray256.c
+hash
 ihex2fw
 ikconfig.h*
 initramfs_data.cpio
+initramfs_data.cpio.bz2
 initramfs_data.cpio.gz
 initramfs_list
 kallsyms
-kconfig
 keywords.c
 ksym.c*
 ksym.h*
@@ -133,7 +145,9 @@ mkboot
 mkbugboot
 mkcpustr
 mkdep
+mkpiggy
 mkprep
+mkregtable
 mktables
 mktree
 modpost
@@ -149,6 +163,7 @@ patches*
 pca200e.bin
 pca200e_ecd.bin2
 piggy.gz
+piggy.S
 piggyback
 pnmtologo
 ppc_defs.h*
@@ -157,12 +172,14 @@ qconf
 raid6altivec*.c
 raid6int*.c
 raid6tables.c
+regdb.c
 relocs
 series
 setup
 setup.bin
 setup.elf
 sImage
+slabinfo
 sm_tbl*
 split-include
 syscalltab.h
@@ -186,14 +203,20 @@ version.h*
 vmlinux
 vmlinux-*
 vmlinux.aout
+vmlinux.bin.all
+vmlinux.bin.bz2
 vmlinux.lds
+vmlinux.relocs
+voffset.h
 vsyscall.lds
 vsyscall_32.lds
 wanxlfw.inc
 uImage
 unifdef
+utsrelease.h
 wakeup.bin
 wakeup.elf
 wakeup.lds
 zImage*
 zconf.hash.c
+zoffset.h
diff -urNp linux-2.6.32.24/drivers/acpi/acpi_pad.c linux-2.6.32.24/drivers/acpi/acpi_pad.c
--- linux-2.6.32.24/drivers/acpi/acpi_pad.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/acpi_pad.c	2010-09-04 15:54:51.000000000 -0400
@@ -30,7 +30,7 @@
 #include <acpi/acpi_bus.h>
 #include <acpi/acpi_drivers.h>
 
-#define ACPI_PROCESSOR_AGGREGATOR_CLASS	"processor_aggregator"
+#define ACPI_PROCESSOR_AGGREGATOR_CLASS	"acpi_pad"
 #define ACPI_PROCESSOR_AGGREGATOR_DEVICE_NAME "Processor Aggregator"
 #define ACPI_PROCESSOR_AGGREGATOR_NOTIFY 0x80
 static DEFINE_MUTEX(isolated_cpus_lock);
diff -urNp linux-2.6.32.24/drivers/acpi/battery.c linux-2.6.32.24/drivers/acpi/battery.c
--- linux-2.6.32.24/drivers/acpi/battery.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/battery.c	2010-09-04 15:54:51.000000000 -0400
@@ -763,7 +763,7 @@ DECLARE_FILE_FUNCTIONS(alarm);
 	}
 
 static struct battery_file {
-	struct file_operations ops;
+	const struct file_operations ops;
 	mode_t mode;
 	const char *name;
 } acpi_battery_file[] = {
diff -urNp linux-2.6.32.24/drivers/acpi/blacklist.c linux-2.6.32.24/drivers/acpi/blacklist.c
--- linux-2.6.32.24/drivers/acpi/blacklist.c	2010-09-26 17:26:05.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/blacklist.c	2010-09-26 17:26:38.000000000 -0400
@@ -73,7 +73,7 @@ static struct acpi_blacklist_item acpi_b
 	{"IBM   ", "TP600E  ", 0x00000105, ACPI_SIG_DSDT, less_than_or_equal,
 	 "Incorrect _ADR", 1},
 
-	{""}
+	{"", "", 0, NULL, all_versions, NULL, 0}
 };
 
 #if	CONFIG_ACPI_BLACKLIST_YEAR
diff -urNp linux-2.6.32.24/drivers/acpi/dock.c linux-2.6.32.24/drivers/acpi/dock.c
--- linux-2.6.32.24/drivers/acpi/dock.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/dock.c	2010-09-04 15:54:51.000000000 -0400
@@ -77,7 +77,7 @@ struct dock_dependent_device {
 	struct list_head list;
 	struct list_head hotplug_list;
 	acpi_handle handle;
-	struct acpi_dock_ops *ops;
+	const struct acpi_dock_ops *ops;
 	void *context;
 };
 
@@ -605,7 +605,7 @@ EXPORT_SYMBOL_GPL(unregister_dock_notifi
  * the dock driver after _DCK is executed.
  */
 int
-register_hotplug_dock_device(acpi_handle handle, struct acpi_dock_ops *ops,
+register_hotplug_dock_device(acpi_handle handle, const struct acpi_dock_ops *ops,
 			     void *context)
 {
 	struct dock_dependent_device *dd;
diff -urNp linux-2.6.32.24/drivers/acpi/osl.c linux-2.6.32.24/drivers/acpi/osl.c
--- linux-2.6.32.24/drivers/acpi/osl.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/osl.c	2010-09-04 15:54:51.000000000 -0400
@@ -523,6 +523,8 @@ acpi_os_read_memory(acpi_physical_addres
 	void __iomem *virt_addr;
 
 	virt_addr = ioremap(phys_addr, width);
+	if (!virt_addr)
+		return AE_NO_MEMORY;
 	if (!value)
 		value = &dummy;
 
@@ -551,6 +553,8 @@ acpi_os_write_memory(acpi_physical_addre
 	void __iomem *virt_addr;
 
 	virt_addr = ioremap(phys_addr, width);
+	if (!virt_addr)
+		return AE_NO_MEMORY;
 
 	switch (width) {
 	case 8:
diff -urNp linux-2.6.32.24/drivers/acpi/power_meter.c linux-2.6.32.24/drivers/acpi/power_meter.c
--- linux-2.6.32.24/drivers/acpi/power_meter.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/power_meter.c	2010-09-04 15:54:51.000000000 -0400
@@ -315,8 +315,6 @@ static ssize_t set_trip(struct device *d
 		return res;
 
 	temp /= 1000;
-	if (temp < 0)
-		return -EINVAL;
 
 	mutex_lock(&resource->lock);
 	resource->trip[attr->index - 7] = temp;
diff -urNp linux-2.6.32.24/drivers/acpi/proc.c linux-2.6.32.24/drivers/acpi/proc.c
--- linux-2.6.32.24/drivers/acpi/proc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/proc.c	2010-09-04 15:54:51.000000000 -0400
@@ -391,20 +391,15 @@ acpi_system_write_wakeup_device(struct f
 				size_t count, loff_t * ppos)
 {
 	struct list_head *node, *next;
-	char strbuf[5];
-	char str[5] = "";
-	unsigned int len = count;
+	char strbuf[5] = {0};
 	struct acpi_device *found_dev = NULL;
 
-	if (len > 4)
-		len = 4;
-	if (len < 0)
-		return -EFAULT;
+	if (count > 4)
+		count = 4;
 
-	if (copy_from_user(strbuf, buffer, len))
+	if (copy_from_user(strbuf, buffer, count))
 		return -EFAULT;
-	strbuf[len] = '\0';
-	sscanf(strbuf, "%s", str);
+	strbuf[count] = '\0';
 
 	mutex_lock(&acpi_device_lock);
 	list_for_each_safe(node, next, &acpi_wakeup_device_list) {
@@ -413,7 +408,7 @@ acpi_system_write_wakeup_device(struct f
 		if (!dev->wakeup.flags.valid)
 			continue;
 
-		if (!strncmp(dev->pnp.bus_id, str, 4)) {
+		if (!strncmp(dev->pnp.bus_id, strbuf, 4)) {
 			dev->wakeup.state.enabled =
 			    dev->wakeup.state.enabled ? 0 : 1;
 			found_dev = dev;
diff -urNp linux-2.6.32.24/drivers/acpi/processor_core.c linux-2.6.32.24/drivers/acpi/processor_core.c
--- linux-2.6.32.24/drivers/acpi/processor_core.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/processor_core.c	2010-09-04 15:54:51.000000000 -0400
@@ -796,7 +796,7 @@ static int __cpuinit acpi_processor_add(
 		return 0;
 	}
 
-	BUG_ON((pr->id >= nr_cpu_ids) || (pr->id < 0));
+	BUG_ON(pr->id >= nr_cpu_ids);
 
 	/*
 	 * Buggy BIOS check
diff -urNp linux-2.6.32.24/drivers/acpi/processor_idle.c linux-2.6.32.24/drivers/acpi/processor_idle.c
--- linux-2.6.32.24/drivers/acpi/processor_idle.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/processor_idle.c	2010-09-04 15:54:51.000000000 -0400
@@ -118,7 +118,7 @@ static struct dmi_system_id __cpuinitdat
 	  DMI_MATCH(DMI_SYS_VENDOR, "ASUSTeK Computer Inc."),
 	  DMI_MATCH(DMI_PRODUCT_NAME,"L8400B series Notebook PC")},
 	 (void *)1},
-	{},
+	{ NULL, NULL, {DMI_MATCH(DMI_NONE, {0})}, NULL},
 };
 
 
diff -urNp linux-2.6.32.24/drivers/acpi/sbshc.c linux-2.6.32.24/drivers/acpi/sbshc.c
--- linux-2.6.32.24/drivers/acpi/sbshc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/sbshc.c	2010-09-04 15:54:51.000000000 -0400
@@ -17,7 +17,7 @@
 
 #define PREFIX "ACPI: "
 
-#define ACPI_SMB_HC_CLASS	"smbus_host_controller"
+#define ACPI_SMB_HC_CLASS	"smbus_host_ctl"
 #define ACPI_SMB_HC_DEVICE_NAME	"ACPI SMBus HC"
 
 struct acpi_smb_hc {
diff -urNp linux-2.6.32.24/drivers/acpi/sleep.c linux-2.6.32.24/drivers/acpi/sleep.c
--- linux-2.6.32.24/drivers/acpi/sleep.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/sleep.c	2010-09-04 15:54:51.000000000 -0400
@@ -283,7 +283,7 @@ static int acpi_suspend_state_valid(susp
 	}
 }
 
-static struct platform_suspend_ops acpi_suspend_ops = {
+static const struct platform_suspend_ops acpi_suspend_ops = {
 	.valid = acpi_suspend_state_valid,
 	.begin = acpi_suspend_begin,
 	.prepare_late = acpi_pm_prepare,
@@ -311,7 +311,7 @@ static int acpi_suspend_begin_old(suspen
  * The following callbacks are used if the pre-ACPI 2.0 suspend ordering has
  * been requested.
  */
-static struct platform_suspend_ops acpi_suspend_ops_old = {
+static const struct platform_suspend_ops acpi_suspend_ops_old = {
 	.valid = acpi_suspend_state_valid,
 	.begin = acpi_suspend_begin_old,
 	.prepare_late = acpi_pm_disable_gpes,
@@ -460,7 +460,7 @@ static void acpi_pm_enable_gpes(void)
 	acpi_enable_all_runtime_gpes();
 }
 
-static struct platform_hibernation_ops acpi_hibernation_ops = {
+static const struct platform_hibernation_ops acpi_hibernation_ops = {
 	.begin = acpi_hibernation_begin,
 	.end = acpi_pm_end,
 	.pre_snapshot = acpi_hibernation_pre_snapshot,
@@ -513,7 +513,7 @@ static int acpi_hibernation_pre_snapshot
  * The following callbacks are used if the pre-ACPI 2.0 suspend ordering has
  * been requested.
  */
-static struct platform_hibernation_ops acpi_hibernation_ops_old = {
+static const struct platform_hibernation_ops acpi_hibernation_ops_old = {
 	.begin = acpi_hibernation_begin_old,
 	.end = acpi_pm_end,
 	.pre_snapshot = acpi_hibernation_pre_snapshot_old,
diff -urNp linux-2.6.32.24/drivers/acpi/video.c linux-2.6.32.24/drivers/acpi/video.c
--- linux-2.6.32.24/drivers/acpi/video.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/acpi/video.c	2010-09-04 15:54:51.000000000 -0400
@@ -359,7 +359,7 @@ static int acpi_video_set_brightness(str
 				vd->brightness->levels[request_level]);
 }
 
-static struct backlight_ops acpi_backlight_ops = {
+static const struct backlight_ops acpi_backlight_ops = {
 	.get_brightness = acpi_video_get_brightness,
 	.update_status  = acpi_video_set_brightness,
 };
diff -urNp linux-2.6.32.24/drivers/ata/ahci.c linux-2.6.32.24/drivers/ata/ahci.c
--- linux-2.6.32.24/drivers/ata/ahci.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/ahci.c	2010-09-04 15:54:51.000000000 -0400
@@ -387,7 +387,7 @@ static struct scsi_host_template ahci_sh
 	.sdev_attrs		= ahci_sdev_attrs,
 };
 
-static struct ata_port_operations ahci_ops = {
+static const struct ata_port_operations ahci_ops = {
 	.inherits		= &sata_pmp_port_ops,
 
 	.qc_defer		= sata_pmp_qc_defer_cmd_switch,
@@ -424,17 +424,17 @@ static struct ata_port_operations ahci_o
 	.port_stop		= ahci_port_stop,
 };
 
-static struct ata_port_operations ahci_vt8251_ops = {
+static const struct ata_port_operations ahci_vt8251_ops = {
 	.inherits		= &ahci_ops,
 	.hardreset		= ahci_vt8251_hardreset,
 };
 
-static struct ata_port_operations ahci_p5wdh_ops = {
+static const struct ata_port_operations ahci_p5wdh_ops = {
 	.inherits		= &ahci_ops,
 	.hardreset		= ahci_p5wdh_hardreset,
 };
 
-static struct ata_port_operations ahci_sb600_ops = {
+static const struct ata_port_operations ahci_sb600_ops = {
 	.inherits		= &ahci_ops,
 	.softreset		= ahci_sb600_softreset,
 	.pmp_softreset		= ahci_sb600_softreset,
@@ -687,7 +687,7 @@ static const struct pci_device_id ahci_p
 	{ PCI_ANY_ID, PCI_ANY_ID, PCI_ANY_ID, PCI_ANY_ID,
 	  PCI_CLASS_STORAGE_SATA_AHCI, 0xffffff, board_ahci },
 
-	{ }	/* terminate list */
+	{ 0, 0, 0, 0, 0, 0, 0 }	/* terminate list */
 };
 
 
diff -urNp linux-2.6.32.24/drivers/ata/ata_generic.c linux-2.6.32.24/drivers/ata/ata_generic.c
--- linux-2.6.32.24/drivers/ata/ata_generic.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/ata_generic.c	2010-09-04 15:54:51.000000000 -0400
@@ -95,7 +95,7 @@ static struct scsi_host_template generic
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations generic_port_ops = {
+static const struct ata_port_operations generic_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= ata_cable_unknown,
 	.set_mode	= generic_set_mode,
diff -urNp linux-2.6.32.24/drivers/ata/ata_piix.c linux-2.6.32.24/drivers/ata/ata_piix.c
--- linux-2.6.32.24/drivers/ata/ata_piix.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/ata_piix.c	2010-09-04 15:54:51.000000000 -0400
@@ -300,7 +300,7 @@ static const struct pci_device_id piix_p
 	{ 0x8086, 0x1c08, PCI_ANY_ID, PCI_ANY_ID, 0, 0, ich8_2port_sata },
 	/* SATA Controller IDE (CPT) */
 	{ 0x8086, 0x1c09, PCI_ANY_ID, PCI_ANY_ID, 0, 0, ich8_2port_sata },
-	{ }	/* terminate list */
+	{ 0, 0, 0, 0, 0, 0, 0 }	/* terminate list */
 };
 
 static struct pci_driver piix_pci_driver = {
@@ -318,7 +318,7 @@ static struct scsi_host_template piix_sh
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations piix_pata_ops = {
+static const struct ata_port_operations piix_pata_ops = {
 	.inherits		= &ata_bmdma32_port_ops,
 	.cable_detect		= ata_cable_40wire,
 	.set_piomode		= piix_set_piomode,
@@ -326,22 +326,22 @@ static struct ata_port_operations piix_p
 	.prereset		= piix_pata_prereset,
 };
 
-static struct ata_port_operations piix_vmw_ops = {
+static const struct ata_port_operations piix_vmw_ops = {
 	.inherits		= &piix_pata_ops,
 	.bmdma_status		= piix_vmw_bmdma_status,
 };
 
-static struct ata_port_operations ich_pata_ops = {
+static const struct ata_port_operations ich_pata_ops = {
 	.inherits		= &piix_pata_ops,
 	.cable_detect		= ich_pata_cable_detect,
 	.set_dmamode		= ich_set_dmamode,
 };
 
-static struct ata_port_operations piix_sata_ops = {
+static const struct ata_port_operations piix_sata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 };
 
-static struct ata_port_operations piix_sidpr_sata_ops = {
+static const struct ata_port_operations piix_sidpr_sata_ops = {
 	.inherits		= &piix_sata_ops,
 	.hardreset		= sata_std_hardreset,
 	.scr_read		= piix_sidpr_scr_read,
@@ -617,7 +617,7 @@ static const struct ich_laptop ich_lapto
 	{ 0x2653, 0x1043, 0x82D8 },	/* ICH6M on Asus Eee 701 */
 	{ 0x27df, 0x104d, 0x900e },	/* ICH7 on Sony TZ-90 */
 	/* end marker */
-	{ 0, }
+	{ 0, 0, 0 }
 };
 
 /**
@@ -1101,7 +1101,7 @@ static int piix_broken_suspend(void)
 			},
 		},
 
-		{ }	/* terminate list */
+		{ NULL, NULL, {DMI_MATCH(DMI_NONE, {0})}, NULL }	/* terminate list */
 	};
 	static const char *oemstrs[] = {
 		"Tecra M3,",
diff -urNp linux-2.6.32.24/drivers/ata/libata-acpi.c linux-2.6.32.24/drivers/ata/libata-acpi.c
--- linux-2.6.32.24/drivers/ata/libata-acpi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/libata-acpi.c	2010-09-04 15:54:51.000000000 -0400
@@ -223,12 +223,12 @@ static void ata_acpi_dev_uevent(acpi_han
 	ata_acpi_uevent(dev->link->ap, dev, event);
 }
 
-static struct acpi_dock_ops ata_acpi_dev_dock_ops = {
+static const struct acpi_dock_ops ata_acpi_dev_dock_ops = {
 	.handler = ata_acpi_dev_notify_dock,
 	.uevent = ata_acpi_dev_uevent,
 };
 
-static struct acpi_dock_ops ata_acpi_ap_dock_ops = {
+static const struct acpi_dock_ops ata_acpi_ap_dock_ops = {
 	.handler = ata_acpi_ap_notify_dock,
 	.uevent = ata_acpi_ap_uevent,
 };
diff -urNp linux-2.6.32.24/drivers/ata/libata-core.c linux-2.6.32.24/drivers/ata/libata-core.c
--- linux-2.6.32.24/drivers/ata/libata-core.c	2010-09-20 17:26:42.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/libata-core.c	2010-09-20 17:27:14.000000000 -0400
@@ -900,7 +900,7 @@ static const struct ata_xfer_ent {
 	{ ATA_SHIFT_PIO, ATA_NR_PIO_MODES, XFER_PIO_0 },
 	{ ATA_SHIFT_MWDMA, ATA_NR_MWDMA_MODES, XFER_MW_DMA_0 },
 	{ ATA_SHIFT_UDMA, ATA_NR_UDMA_MODES, XFER_UDMA_0 },
-	{ -1, },
+	{ -1, 0, 0 }
 };
 
 /**
@@ -3168,7 +3168,7 @@ static const struct ata_timing ata_timin
 	{ XFER_UDMA_5,     0,   0,   0,   0,   0,   0, 0,    0,  20 },
 	{ XFER_UDMA_6,     0,   0,   0,   0,   0,   0, 0,    0,  15 },
 
-	{ 0xFF }
+	{ 0xFF, 0, 0, 0, 0, 0, 0, 0, 0 }
 };
 
 #define ENOUGH(v, unit)		(((v)-1)/(unit)+1)
@@ -4393,7 +4393,7 @@ static const struct ata_blacklist_entry 
 	{ "PIONEER DVD-RW  DVRTD08",	"1.00",	ATA_HORKAGE_NOSETXFER },
 
 	/* End Marker */
-	{ }
+	{ NULL, NULL, 0 }
 };
 
 static int strn_pattern_cmp(const char *patt, const char *name, int wildchar)
@@ -5981,7 +5981,7 @@ static void ata_host_stop(struct device 
  *	LOCKING:
  *	None.
  */
-static void ata_finalize_port_ops(struct ata_port_operations *ops)
+static void ata_finalize_port_ops(const struct ata_port_operations *ops)
 {
 	static DEFINE_SPINLOCK(lock);
 	const struct ata_port_operations *cur;
@@ -5993,6 +5993,7 @@ static void ata_finalize_port_ops(struct
 		return;
 
 	spin_lock(&lock);
+	pax_open_kernel();
 
 	for (cur = ops->inherits; cur; cur = cur->inherits) {
 		void **inherit = (void **)cur;
@@ -6006,8 +6007,9 @@ static void ata_finalize_port_ops(struct
 		if (IS_ERR(*pp))
 			*pp = NULL;
 
-	ops->inherits = NULL;
+	((struct ata_port_operations *)ops)->inherits = NULL;
 
+	pax_close_kernel();
 	spin_unlock(&lock);
 }
 
@@ -6104,7 +6106,7 @@ int ata_host_start(struct ata_host *host
  */
 /* KILLME - the only user left is ipr */
 void ata_host_init(struct ata_host *host, struct device *dev,
-		   unsigned long flags, struct ata_port_operations *ops)
+		   unsigned long flags, const struct ata_port_operations *ops)
 {
 	spin_lock_init(&host->lock);
 	host->dev = dev;
@@ -6767,7 +6769,7 @@ static void ata_dummy_error_handler(stru
 	/* truly dummy */
 }
 
-struct ata_port_operations ata_dummy_port_ops = {
+const struct ata_port_operations ata_dummy_port_ops = {
 	.qc_prep		= ata_noop_qc_prep,
 	.qc_issue		= ata_dummy_qc_issue,
 	.error_handler		= ata_dummy_error_handler,
